package org.jvnet.libpam;

import org.jvnet.libpam.impl.CLibrary.passwd;

/**
 * Represents an Unix user. Immutable.
 *
 * @author Kohsuke Kawaguchi
 */
public final class UnixUser {
    private final String userName;
    private final short uid,gid;

    /*package*/ UnixUser(String userName, passwd pwd) {
        this.userName = userName;
        this.uid = pwd.pw_uid;
        this.gid = pwd.pw_gid;
    }

    /**
     * Gets the unix account name. Never null.
     */
    public String getUserName() {
        return userName;
    }

    /**
     * Gets the UID of this user.
     */
    public short getUID() {
        return uid;
    }

    /**
     * Gets the GID of this user.
     */
    public short getGID() {
        return gid;
    }
}
